<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Gamma Ray 技術交流區</title>
    <link rel="stylesheet" href="{{ url_for('static' , filename = '/css/style.css') }}">
    <script src="{{ url_for('static' , filename = '/js/jquery-3.6.0.min.js')}}"></script>
    <script src="{{ url_for('static' , filename = '/js/jquery.cookie.js')}}"></script>
    <link rel="stylesheet" href="{{ url_for('static' , filename = '/js/jquery-ui/jquery-ui.min.css')}}">
    <script src="{{ url_for('static' , filename = '/js/jquery-ui/jquery-ui.min.js') }}"></script>
    <script src="{{ url_for('static' , filename = '/js/jquery.md5.js')}}"></script>

</head>
<body align='center'>
    <h1>Gamma Ray 技術交流區</h1>
    <hr>
    <h2>狀態</h2>
    {% if login_status != undefined %}
      {% if login_status %}
        <span class="login">已登入</span>
      {% else %}
        <span class="logout">未登入</span>
        {% if login_msg != undefined and login_msg != '' %}
          <span class='wrong'> ({{ login_msg }}) </span>
        {% endif %}
      {% endif %}
    {% endif %}
    <hr>
    {% if login_status != undefined %}
    {% if login_status == False %}
    <button id='btnShowLogin' class="ui-button ui-corner-all ui-widget">登入帳號</button>
    <button id='btnShowRegister' class="ui-button ui-corner-all ui-widget">註冊帳號</button>
    <div align='center'>
      <div id="divLogin">
        <div class='divLogin'>
          <h2>登入帳號</h2>
          <form id='loginForm' action="/login" method="POST">
            <div>
              帳號 : <input id="edtAccount" type="text" name="account" /><br>
              密碼 : <input id="edtPassword" type="password" name="password"/><br>
            </div>
          </form>
          <br>
          <div class='divRememberMe' align='right'>
            <input id="chkRememberMe" type="checkbox" name="isRememberMe" value="true"/>記住我 <br/>
          </div>
        </div>
        <button id="btnLogin" class='ui-button ui-corner-all ui-widget'>登入</button>
      </div>
      <div id="divRegister" class='hide'>
        <div class='divLogin'>
          <h2>註冊帳號</h2>
          <form id='registerForm' action="/register" method="POST" enctype = "multipart/form-data">
            <div align='left'>
              頭像 : <input type = "file" name = "photo"/><br>
              名稱 : <input type="text" name="name" /><br>
              <br>
              帳號 : <input type="text" name="account" /><br>
              密碼 : <input id="registerPWD" type="password" name="password"/><br>
            </div>
          </form>
          <br>
        </div>
        <button id='btnRegister' class='ui-button ui-corner-all ui-widget'>註冊</button>
      </div>
    </div>
    <hr>
      {% else %}
      <button id='btnShowAllArticle' class="ui-button ui-corner-all ui-widget">全部文章</button>
      <button id='btnShowMemberInfo' class="ui-button ui-corner-all ui-widget">會員資料</button>
      <button id='btnLogout' class="ui-button ui-corner-all ui-widget">登出系統</button>
      <div align='center'>
        <br>
        <div id='divArticle'>
          <div align="center">
              <table border="1">
                  <thead>
                  <tr>
                      <th width='100'>title</th>
                      <th width='100'>author</th>
                      <th width='300'>date</th>
                      <th width='100'>action</th>
                  </tr>
                  </thead>
                  <tbody id='tableData' align="center">
                      {% for article in lstArticle %}
                      <tr >
                          <th> {{ article.title }} </th>
                          <td> {{ article.author }} </td>
                          <td> {{ article.date }} </td>
                          <td>
                              <button name='btnShow' data-index='{{ loop.index }}'>show</button>
                          </td>
                      </tr>
                      {% endfor %}
                  </tbody>
              </table>
          </div>
          <br>
          <div id=actionDiv>
              <button id="btnNew" class='ui-button ui-corner-all ui-widget'>新增</button>
              <button id="btnEdit" class='ui-button ui-corner-all ui-widget hide'>修改</button>
              <button id="btnDelete" class='ui-button ui-corner-all ui-widget hide'>刪除</button>
          </div>
          <br>
          <div id="showDiv" class="article hide" align='center'>
              <h2 id='txt_title'></h2>
              <div id='txt_content'></div>
              <p>Author : <span id='txt_author'></span>&nbsp;&nbsp;&nbsp;Date : <span id='txt_date'></span></p>
          </div>
          <div id="editDiv" class="hide">
              <form id='editForm' action="/add" method="post">
                  <input type="hidden" id='edt_id' name='id'>
                  <label for="title">標題 : </label>
                  <input type='text' id='edt_title' name='title'/><br><br>
                  <textarea rows="10" cols="75" id='edt_content' name="content"></textarea><br><br>
              </form>
          </div>
          <h2 id='msg'></h2>
          <button id='btnNo' class='ui-button ui-corner-all ui-widget hide'>取消</button>
          <button id='btnYes' class='ui-button ui-corner-all ui-widget hide'>確認</button>
        </div>
        <div id="divMember" class='hide'>
          <div class="member">
            <img src="{{ url_for('static', filename='img/' + user_info.photo)}}" alt="" width="150">
            <p>名稱 : {{ user_info.name }}</p>
            <p>帳號 : {{ user_info.account}}</p>
          </div>
          <div class='divLogin'>
            <h2>修改密碼</h2>
            <form id='changeForm' action="/change" method="POST">
              <div>
              原密碼 : <input type="password" name="oldPassword"/><br>
              新密碼 : <input type="password" name="newPassword"/><br>
              再ㄧ次 : <input type="password" name="chkPassword"/>
              </div>
            </form>
            <br>
          </div>
          <button id='btnChange' class='ui-button ui-corner-all ui-widget'>確認</button>
        </div>
      </div>
      {% endif %}
    {% endif %}

    <script type=text/javascript>
      $(function() {
        var $btnShowLogin = $('#btnShowLogin');
        var $btnShowRegister = $('#btnShowRegister');

        var $divLogin = $('#divLogin');
        var $divRegister = $('#divRegister');

        var $loginForm = $('#loginForm');
        var $registerPWD = $('#registerPWD');
        var $registerForm = $('#registerForm');
        var $changeForm = $('#changeForm');

        var $btnLogin = $('#btnLogin');
        var $btnRegister = $('#btnRegister');
        var $btnLogout = $('#btnLogout');
        var $btnChange = $('#btnChange');

        var $tableData = $('#tableData');

        var login_status = {{ login_status | tojson }};

        $btnShowLogin.off('click').on('click',function(){
          $divLogin.show();
          $divRegister.hide();
        });

        $btnShowRegister.off('click').on('click',function(){
          $divLogin.hide();
          $divRegister.show();
        });
        
        $( "#controlgroup" ).controlgroup();

        $btnLogin.off('click').on('click',function(){
            var account = $('#edtAccount').val();
            var password = $('#edtPassword').val();
            var isRememberMe = $('#chkRememberMe').prop("checked");
            
            password = $.md5(password);
            $('#edtPassword').val(password);

            if(isRememberMe){
              $.cookie("account", account, { expires: 1, path: "/" });
              $.cookie("isRememberMe", isRememberMe, { expires: 1, path: "/" });
            }
            $loginForm.submit();
        });

        $btnRegister.off('click').on('click',function(){
          var password = $('#registerPWD').val();
          password = $.md5(password);
          $('#registerPWD').val(password);
          $registerForm.submit();
        });

        $btnLogout.off('click').on('click' , function(){
          location.href = '/logout';
        });

        $btnChange.off('click').on('click' , function(){
          var oldPassword = $('[name=oldPassword]').val();
          var newPassword = $('[name=newPassword]').val();
          var chkPassword = $('[name=chkPassword]').val();

          oldPassword = $.md5(oldPassword);
          newPassword = $.md5(newPassword);
          chkPassword = $.md5(chkPassword);
          
          $('[name=oldPassword]').val(oldPassword);
          $('[name=newPassword]').val(newPassword);
          $('[name=chkPassword').val(chkPassword);

          $changeForm.submit();
        });

        // Article
        var lstArticle = [];
        var index = -1;
        var action = '';

        var queryArticleData = function(){
          $.ajax({
              url: '/article',
              data: {},
              type: 'GET',
              success: function (data) {
                console.log(data);
                $tableData.empty();
                lstArticle = []
                $.each(data , function(idx , val){
                  $tableData.append('<tr>');
                  $tableData.append('<td>' + val.title + '</td>');
                  $tableData.append('<td>' + val.author + '</td>');
                  $tableData.append('<td>' + val.date + '</td>');
                  $tableData.append('<td><button name="btnShow" class="ui-button ui-corner-all" data-index=' + idx + '>show</button></td>');
                  $tableData.append('</tr>');
                  lstArticle.push(val);
                  initArticleView();
                });
              },
              error: function (xhr) {
                  alert('Ajax request 發生錯誤');
              }
          });
        }

        var initArticleView = function(){
          $btnShow = $('[name=btnShow]');

          $btnNew = $('#btnNew');
          $btnEdit = $('#btnEdit');
          $btnDelete = $('#btnDelete');

          $btnYes = $('#btnYes');
          $btnNo = $('#btnNo');

          $showDiv = $('#showDiv');
          $editDiv = $('#editDiv');
          $msg = $('#msg')
          
          $txtTitle = $('#txt_title');
          $txtContent = $('#txt_content');
          $txtAuthor = $('#txt_author');
          $txtDate = $('#txt_date');

          $edtId = $('#edt_id');
          $edtTitle = $('#edt_title');
          $edtContent = $('#edt_content');

          $editForm = $('#editForm');

          $btnShowAllArticle = $('#btnShowAllArticle');
          $btnShowMemberInfo = $('#btnShowMemberInfo');
          $divArticle = $('#divArticle');
          $divMember = $('#divMember');

          $btnShowAllArticle.off('click').on('click' , function() {
            $divArticle.show();
            $divMember.hide();
          });

          $btnShowMemberInfo.off('click').on('click' , function() {
            $divArticle.hide();
            $divMember.show();
          });

          $btnShow.off('click').on('click' , function(){
            index = $(this).attr('data-index');

            let article = lstArticle[index];
            console.log(article);
            $edtId.val(article.id);
            $edtTitle.val(article.title);
            $edtContent.val(article.content);

            $txtTitle.html(article.title);
            $txtContent.html(article.content.replace(/(\r\n)|(\n)/g,'<br>'));
            $txtAuthor.html(article.author);
            $txtDate.html(article.date);

            $btnNew.hide();
            $btnEdit.show();
            $btnDelete.show();

            $showDiv.show();
            $editDiv.hide();
            $btnYes.hide();
            $btnNo.show();
          });


          $btnNew.off('click').on('click' , function(){
            action = 'new';
            $edtTitle.text('');
            $edtContent.text('');

            $btnNew.hide();
            $btnEdit.hide();
            $btnDelete.hide();

            $showDiv.hide();
            $editDiv.show();
            $btnYes.show();
            $btnNo.show();
          });

          $btnEdit.off('click').on('click' , function(){
            action = 'edit';

            $btnNew.hide();
            $btnEdit.hide();
            $btnDelete.hide();                

            $showDiv.hide();
            $editDiv.show();
            $btnYes.show();
            $btnNo.show();
          });

          $btnDelete.off('click').on('click' , function(){
            action = 'delete';

            $msg.show();
            $msg.text('確定 ?');

            $btnNew.hide();
            $btnEdit.hide();
            $btnDelete.hide();  

            $showDiv.hide();
            $editDiv.hide();
            $btnYes.show();
            $btnNo.show();
          });

          $btnYes.off('click').on('click' , function() {
            if(action == 'new'){
                $.ajax({
                  url: '/article/add',
                  data: {
                    title : $edtTitle.val() , 
                    content : $edtContent.val()
                  },
                  type: 'POST',
                  success: function (data) {
                    queryArticleData();
                  },
                  error: function (xhr) {
                      alert('Ajax request 發生錯誤');
                  }
                }); 
            }
            if(action == 'edit'){
              $.ajax({
                url: '/article/edit',
                data: {
                  id : $edtId.val(),
                  title : $edtTitle.val() , 
                  content : $edtContent.val()
                },
                type: 'PUT',
                success: function (data) {
                  console.log(data);
                  $tableData.empty();
                  lstArticle = []
                  $.each(data , function(idx , val){
                    queryArticleData();
                  });
                },
                error: function (xhr) {
                    alert('Ajax request 發生錯誤');
                }
              }); 
            }

            if(action == 'delete'){
                $.ajax({
                  url: '/article/delete',
                  data: {
                    id : $edtId.val()
                  },
                  type: 'DELETE',
                  success: function (data) {
                    queryArticleData();
                  },
                  error: function (xhr) {
                      alert('Ajax request 發生錯誤');
                  }
                }); 

            }

            $msg.hide();
          });

          $btnNo.off('click').on('click' , function() {
            $edtId.val('');
            $edtTitle.val('');
            $edtContent.val('');

            $btnNew.show();
            $btnEdit.hide();
            $btnDelete.hide();
            $showDiv.hide();
            $editDiv.hide();
            $btnYes.hide();
            $btnNo.hide();
            $msg.hide();
          });
          $btnNew.show();
          $btnEdit.hide();
          $btnDelete.hide();

          $showDiv.hide();
          $editDiv.hide();
          $btnYes.hide();
          $btnNo.hide();
        }
        

        function showLoginInfo() {
            let account = $.cookie("account");
            let isRememberMe = $.cookie("isRememberMe") == "true";
            console.log(isRememberMe)
            console.log(account)
            if (isRememberMe) {
              $('#edtAccount').val(account);
            } else {
              $('#edtAccount').val("");
            }
            $('#chkRememberMe').prop("checked", isRememberMe);
            $('#edtPassword').val("");
        }
        showLoginInfo();
        
        if(login_status){
          queryArticleData();
        }

      });

    </script>
</body>
</html>